local _, LHP = ...;

local SoundsFrame = CreateFrame("Frame", nil, UIParent);

local WIPE_MESSAGE = "Wipe Time! Into the bad stuff Lefties!";

local DEBUG = false;

local bloodLustPlaying = false;
local bennyHillPlaying = false;
local surrenderPlaying = false;

-- Create the On Screen Display text
local function BuildOnScreenDisplay()
    SoundsFrame.onScreenDisplay = CreateFrame( "MessageFrame", "OnScreenDisplay", UIParent );
    SoundsFrame.onScreenDisplay:SetPoint("LEFT");
    SoundsFrame.onScreenDisplay:SetPoint("RIGHT");
    SoundsFrame.onScreenDisplay:SetHeight(45);
    SoundsFrame.onScreenDisplay:SetInsertMode("TOP");
    SoundsFrame.onScreenDisplay:SetFrameStrata("HIGH");
    SoundsFrame.onScreenDisplay:SetTimeVisible(5);
    SoundsFrame.onScreenDisplay:SetFadeDuration(1);
    SoundsFrame.onScreenDisplay:SetFont("Interface\\AddOns\\LHPToolkit\\media\\fonts\\impfont.ttf", 36, "OUTLINE");
end

-- Handle any of the /lhp commands issued by the player
local function HandleCommands(input)
    local command = string.lower(input);

    if(command == "wipe") then
        SendChatMessage(WIPE_MESSAGE, "RAID"); -- change to raid channel because dead people
    end

    if(command == "config") then
        InterfaceOptionsFrame_OpenToCategory("LHPToolkit")
    end
end

-- Handle Events registered in Init
local function HandleEvents(self, event, ...)
    local _, instanceType = IsInInstance();

    -- Only execute if we're in a dungeon
    if((instanceType == "party" or instanceType == "raid") or DEBUG == true) then
        -- Combat log events for detecting spells cast etc
        if(event == "COMBAT_LOG_EVENT_UNFILTERED") then
            local timestamp, type, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags = ...;

            if(type == "SPELL_CAST_SUCCESS") then
                local spellName = select(13,...);

                if(spellName == "Surrender to Madness") then
                    if (Conf_SurrenderText) then
                        SoundsFrame.onScreenDisplay:AddMessage(sourceName.." has Surrendered to Madness!", 1, 1, 1, 53, 3);
                    end

                    if (Conf_SurrenderSound == true and surrenderPlaying ~= true) then
                        surrenderPlaying = true;
                        PlaySoundFile("Interface\\AddOns\\LHPToolkit\\media\\sounds\\surrender.mp3", "Dialog");
                        C_Timer.After(27, function() surrenderPlaying = false end);
                    end
                end

                if(spellName == "Bloodlust" or spellName == "Time Warp") then
                    if(Conf_Bloodlust == true and bloodLustPlaying ~= true) then
                        bloodLustPlaying = true;
                        PlaySoundFile("Interface\\AddOns\\LHPToolkit\\media\\sounds\\lust.mp3", "Dialog");
                        SoundsFrame.onScreenDisplay:AddMessage("Pop those cooldowns!", 1, 0, 0, 53, 3);
                        C_Timer.After(33, function() bloodLustPlaying = false end);
                    end
                end
            end
        end
    end

    -- Chat Message Handler
    if(event == "CHAT_MSG_RAID") then
        local message = select(1, ...);
	    local player = select(2, ...);

        -- Should only trigger for people who didn't send the message as the sender has the file triggered on typing.
        if(message == WIPE_MESSAGE) then
            if(Conf_BennyHill == true and bennyHillPlaying ~= true) then
                bennyHillPlaying = true;
                PlaySoundFile("Interface\\AddOns\\LHPToolkit\\media\\sounds\\benny_hill.mp3", "Dialog");
                SoundsFrame.onScreenDisplay:AddMessage(player.." has called for a wipe! Stand in bad stuff!", 1, 1, 1, 53, 3);
                C_Timer.After(16, function() bennyHillPlaying = false end);
            end
        end
    end
end

local function Init()
    BuildOnScreenDisplay();

    SLASH_LHP1 = "/lhp";
    SlashCmdList["LHP"] = HandleCommands; -- Set up the slash commands handler

    SoundsFrame:SetScript("OnEvent", HandleEvents);
    SoundsFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
    SoundsFrame:RegisterEvent("CHAT_MSG_RAID")

end

-- End of file, Initialise
Init();
